/* grafik.c - Tabeliranje i graficki prikaz funkcije s x-osom.            */

#include <stdio.h>
#include <math.h>
#define SIR 40  /* Sirina slike. */

main () {
  double xmin, xmax, dx, ymin, ymax, dy, y, x;
  int xosa, k;
  printf ("xmin, xmax, dx? "); scanf ("%lf%lf%lf", &xmin, &xmax, &dx);
  printf ("ymin, ymax?     "); scanf ("%lf%lf",    &ymin, &ymax);
  putchar ('\n');
  dy = (ymax - ymin) / (SIR - 1);
  xosa = -ymin / dy;
  for (x=xmin; x<=xmax; x+=dx) {
    y = exp (-0.1*x) * sin (x);
    k = (y - ymin) / dy;
    printf ("%9.3f %9.3f ", x, y);
    if (k>=0 && k<SIR) {
      if (k <= xosa) {
        printf ("%*c", k+1, '*');
        if (xosa>k && xosa<SIR) printf ("%*c", xosa-k, '|');
      } else {
        if (xosa >=0) printf ("%*c%*c", xosa+1, '|', k-xosa, '*');
        else          printf ("%*c", k+1, '*');
      }
    } else if (xosa>=0 || x<SIR) printf ("%*c", xosa+1, '|');
    putchar ('\n');
  }
}