/* lagranz.c - Tabeliranje Lagranzovog polinoma                           */

double lagranz (const double X[], const double Y[], int n, double x) {
  double p, q; int i, j;
  for (p=i=0; i<n; i++) {
    for (q=Y[i], j=0; j<n; j++)
      if (j != i) q *= (x-X[j]) / (X[i]-X[j]);
    p += q;
  }
  return p;
}

#include <stdio.h>

main () {
  double X[100], Y[100], x, xmin, xmax, dx;
  int n, i;
  printf ("n? "); scanf ("%d", &n);
  for (i=0; i<n; i++) {
    printf ("x[%d], y[%d]? ", i, i);
    scanf ("%lf%lf", &X[i], &Y[i]);
  }
  printf ("xmin, xmax, dx? ");
  scanf ("%lf%lf%lf", &xmin, &xmax, &dx);
  printf ("\n     x            p(x)\n"
          "========================\n");
  for (x=xmin; x<=xmax; x+=dx) {
    printf ("%12.2f%12.2f\n", x, lagranz(X,Y,n,x));
  }
}
